image: docker:latest

services:
  - docker:dind

variables:
  GIT_SSL_NO_VERIFY: "true"

stages:
  - build

build:
  stage: build
  services:
    - docker:dind
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - |+
      docker build --pull -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME .

      result=`echo "$CI_COMMIT_REF_NAME" | sed -nE 's/^([0-9]+)\.([0-9]+)\.([0-9]+)-siriux-([0-9]+)$/\1 \2 \3 \4/p'`
      if [ -n "$result" ]; then
        mayor=`echo $result | awk '{print $1}'`
        minor=`echo $result | awk '{print $2}'`
        patch=`echo $result | awk '{print $3}'`
        revision=`echo $result | awk '{print $4}'`

        LABEL_MAYOR="$mayor-siriux"
        LABEL_MINOR="$mayor.$minor-siriux"
        LABEL_PATCH="$mayor.$minor.$patch-siriux"

        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE:${LABEL_MAYOR}
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE:${LABEL_MINOR}
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE:${LABEL_PATCH}

        docker push $CI_REGISTRY_IMAGE:${LABEL_MAYOR}
        docker push $CI_REGISTRY_IMAGE:${LABEL_MINOR}
        docker push $CI_REGISTRY_IMAGE:${LABEL_PATCH} 
      else
        docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
      
        # si el branch es main, se hace el push a latest
        if [ "$CI_COMMIT_REF_NAME" == "main" ]; then 
          docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE:latest
          docker push $CI_REGISTRY_IMAGE:latest; 
        fi
      fi

    - echo "Hecho"
